#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

typedef unsigned char uchar;

const long MAX_WORD_LEN = 260;
const long MAX_PALINDROMES = MAX_WORD_LEN*MAX_WORD_LEN;
char word[MAX_WORD_LEN];

char buf1[MAX_WORD_LEN];
char buf2[MAX_WORD_LEN];

int mp_next[MAX_WORD_LEN];

struct Palindrome
{
	uchar iBegin, iEnd;

	Palindrome()
	{
	}

	Palindrome(uchar beg, uchar end)
	{
		iBegin = beg;
		iEnd = end;
	}

	uchar Length()
	{
		return iEnd-iBegin + 1;
	}

	int IncludesIn(Palindrome p)
	{
		/*
		if(Length() == p.Length())
		{
			return !strncmp(word+iBegin, word+p.iBegin, Length());
		}
		long i, j;
		long len = Length();
		for (i = p.iBegin; i <= p.iEnd-len+1; ++i)
		{
			for (j = iBegin; j <= iEnd && word[i+j-iBegin] == word[j]; ++j);

			if (j > iEnd) return 1;
		}

		return 0;

		*/
		/*
		strncpy(buf1, word+iBegin, iEnd-iBegin+1);
		buf1[iEnd-iBegin+1] = 0;

		char oldCh2 = word[p.iEnd+1];
		word[p.iEnd+1] = 0;
		int res = (strstr(word+p.iBegin, buf1) != 0);

		word[p.iEnd+1] = oldCh2;

		return res;
		*/

		/*long i;
		long len = Length();
		for (i = 0; i <*/
	}
};


int ComparePalindromes(const void* pp1, const void* pp2)
{
	Palindrome* p1 = (Palindrome*)(pp1);
	Palindrome* p2 = (Palindrome*)(pp2);

	if (p1->Length() < p2->Length()) return -1;
	if (p1->Length() > p2->Length()) return 1;
	return 0;
}

Palindrome palindromes[MAX_PALINDROMES];
long cPalindromes;


void GeneratePalindromes()
{
	uchar midIndex, halfLen;
	long len = strlen(word);

	// nechet
    for (midIndex = 0; midIndex < len; ++midIndex)
	{
        for (halfLen = 0; 
			midIndex-halfLen >= 0 && midIndex + halfLen < len &&
			word[midIndex-halfLen] == word[midIndex+halfLen];
			++halfLen)
		{
            if (halfLen > 0)
			{
				palindromes[cPalindromes++] = Palindrome(midIndex-halfLen, midIndex+halfLen);
			}
		}
	}

	// chet
    for (midIndex = 0; midIndex < len; ++midIndex)
	{
        for (halfLen = 0; 
			midIndex-halfLen >= 0 && midIndex + halfLen +1< len &&
			word[midIndex-halfLen] == word[midIndex+halfLen+1];
			++halfLen)
		{
            if (halfLen > 0)
			{
				palindromes[cPalindromes++] = Palindrome(midIndex-halfLen, midIndex+halfLen+1);
			}
		}
	}
}


int IsPalindrome(long begin, long end)
{
	long i;
	for(i=0;end-i>begin+i;++i)
		if(word[begin+i]!=word[end-i])return 0;
	return 1;
}

int Contains(long begin, long end, char*min, long minlen)
{
	long i,j;
	for(i = begin; i <= end-minlen; ++i)
	{
		for(j=0;j<=minlen;++j)
			if(word[i+j]!=*(min+j))break;
		if(j>minlen)return 1;
	}
	return 0;
}

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	for(unsigned long i = 1; i < 65536; ++i)
	{
		if(sqrtl(double(i*i)) - i != 0)
		{
			puts("!!!");
		}
	}

	return 0;

	while (scanf("%s", word) == 1)
	{
		/*cPalindromes = 0;
		GeneratePalindromes();
		qsort(palindromes, cPalindromes, sizeof(palindromes[0]), ComparePalindromes);

		long iPalindrome;
		for (iPalindrome = 0; 
				iPalindrome < cPalindromes - 1 && palindromes[iPalindrome].IncludesIn(palindromes[iPalindrome+1]);
				++iPalindrome);

		if (iPalindrome < cPalindromes-1)
		{
			puts(word);
		}*/

		long len=strlen(word);
		char*min;
		long minlen=0;
		long k,pl;
		for(k=2;k<len;++k)
		{
			for(pl=2;pl<=k;++pl)
				if(IsPalindrome(k-pl,k))
				{
					if(minlen!=0)
					{
						if(!Contains(k-pl,k,min,minlen))
						{
							puts(word);
							goto next;
						}
					}
					if(!minlen || pl < minlen)
					{
						minlen=pl;
						min=word+k-pl;
					}
				}
		}
next:
		minlen=0;
	}


	fclose(stdin);
	fclose(stdout);
	return 0;
}
